/* A screen Editor Subsystem. */

# define Turbo C    /*  餦 櫠 磜 Turbo C  */



# include "stdio.h"   /* standard 㩜 曦-曦  */
# include "dos.h"     /*   DOS */
# include "string.h"  /* 㩜   㣞 */
# include "bios.h"    /* 㩜  ⮦ ⢘  BIOS  */
# include "conio.h"   /*  /  椞  DOS */


# define BUF_SIZE 32000            /* ⚜  buffer */
# define LINE_LEN 79               /* ⚠ 㡦  */
# define MAX_LINES 24              /* 㟦   椞 */
# define KILL_BUF_SIZE 4*LINE_LEN  /* ⚜ buffer   
				      ⤞  */


/* GLOBAL  */

char buf[BUF_SIZE];
/*     ᢢ */

char *curloc, *endloc;
/* 填  室  穘 ⩞
    buf    ⢦  妬  */

int scrnx ,scrny;
/* ⤜  cursor  椞 */

char killbuf[KILL_BUF_SIZE];
/*   ⤞   妬
   驫     櫜    */

char *helpline= "F1:save F2:load F3:find F4 :replace\
^K :kill line ^Y :yank ^Z :quit ";
/*  㟜 */


/*  */

void edit(char *fname);
/*   妬
   
   *fname:填   */


void help (void);
/*  㟜 */


void gotoxy(int x, int y);
/* 夦  ⤜ ⤜  椞
   
   x: 㢞
   y:    */


void clrline(int y);
/* 坜    椞
   
   y:   */


void edit_clr_eol (int x,  int y);
/* H ᨫ  坜  椞 ⮨  棜 carriage
   return  ⮨  ⢦  妬.
   
   x: 
   y: 㢞  */


void clrscr (void);
/* 坜  椞 */


void printline(char *p);
/* 餜   餫
     穘 ⩞  填
   
   *p:填  㨘  ⢦  驦 */


void delete_char(void);
/* ᭜  㨘 
    婡  cursor        */


void tab(void);



void search(void);
/* 婡 ⤘ ⤦ string */


void kill_line(void);
/* ᭜    
     婡  cursor */


void upline(void);
/*  cursor ⨜    */


void downline (void);
/* o cursor ⨜    */


void left (void) ;
/*  cursor ⨜ ⤘ 㨘 .
    壘 㛞    妬  cursor
   ⤜  ⩞                        */


void right (void);
/*  cursor ⨜ ⤘ 㨘 
    棘 㛞  ⢦  妬
    cursor ⤜   ⩞           */


void scrolldn (int x, int y);
/* 夞  㣘  椞   
   
   x: 㢞
   y:                                     */



void scrollup (int topx, int topy ,int endx , int endy );


void display_scrn (int x, int y , char *p);
/* 坜  壜  椞
   
   x: 㢞
   y: 
  *p:填  㨘  ⢦ 驦  */


void pagedown(void) ;
/* 棘  椞  */


void pageup(void) ;
/* 棘  椞   */


void replace (void);
/* 磜 ⤘ string  ᧦ ᢢ */


void home(void);
/* 夦     */


void gotoend(void);
/* 夦  ⢦   */


void yank(void);
/* ᡫ ⤞  */


int load (char *fname);
/* 樫ࣘ 妬
   
   *fname:填     */


int save (char *fname);
/* 驠 妬
   
  *fname:填    */


void edit_gets(char *str);
/*  ᚦ ⤘  .
       ENTER   椞  嫘    */



main (int argc, char *argv[])
{

  if (argc==2) edit (argv[1]);
  /* ⧜  驦 椦 妬  
     ⯜    */

  clrscr();
  /* 坦  椞 */

}


void edit(char *fname)
{
   union k {
      char  ch[2];
      unsigned i;
      } key;   /* 㡫  㟞 */

char name[80];
/*    禬  椦  妬 */


/*  磜  驦   */


if (!load(fname))
     curloc=endloc=buf ;
/*   ᨮ   oi 填 curloc
    endloc 室    buffer */


   strcpy(name,fname);
   clrscr();
/* 禬  椦  妬  
   name   坦  椞 */


scrnx=scrny=0;
/*⫦     */


display_scrn(0,0,curloc);
/* E坜    椞 */


help();
/*餦   㟜*/


gotoxy(0,0);
/* 夦    椞 */



/* Main loop   */

do  {

#ifdef TURBOC
    key.i=bioskey(0);  /*read 16-bit key code  */
#endif

#ifdef  MICROSOFTC
    key.i=_bios_keybrd(0);
#endif

      key.ch[0]=getch();
      /* ᝦ ⤘ 㨘   暠 */


      if (key.ch[0]==0)
      {
	   key.ch[1]=getch();
	   /*  夘  ⚮  夘 
	      竜 㨘  㟞          */

	   switch(key.ch[1] )  {
	   case 59:  /* F1: save file  */

		save (name);

		break;

	   case 60: /*  F2: load file */

		clrline(MAX_LINES);
		gotoxy(0, MAX_LINES);
		/* 坦     椞
		    磜  cursor        */


		printf ("enter filename:");
		edit_gets(name);
		if (*name) load(name);
		/*  ᨮ    餦 */


		help();
		/* 餦   㟜 */


		display_scrn(0,0,curloc);
		scrnx=scrny=0;
		/* 坜    椞  
		     scrnx ,scrny 坦 */


		break;

	   case 61: /* F3 : search */
		search ();
		break;

	   case 62: /* F4: replace */
		replace();
		break;

	   case 71: /* home */
		home();
		break;

	   case 79: /* end */
		gotoend();
		break;

	   case 75: /* left */
		left();
		break;

	   case 77: /* right */
		right ();
		break;

	   case 72: /* up */
		upline();
		break;

	   case 80: /* down */
		downline();
		break;

	   case 73: /* page up */
        	pageup();
		break;

	   case 81: /* page down */
		pagedown();
		break;

	   case 83: /*Del */

		if (curloc<endloc) delete_char();
		/*   壘  ⢦   妬 ᭜ 
		   㨘   棘  */

		break;
		 }


    if (curloc<buf) {
    scrnx=scrny=0;
    curloc=buf;
   /*   填 穘 ⩞ 室    
       妬  ⨦    妬 
      坦   scrnx ,scrny	             */
   }

    gotoxy(scrnx,scrny);
    /*  cursor 嫘  ⤜  椞 */

 }

    else {
    /* ᚦ  㨘   */
      switch (key.ch[0]) {
	  case '\r' : /*carriage return */
	     if ( endloc==buf+BUF_SIZE-2) break;
	     /*   ᨮ 騦  buffer  ᚜
		 carriage return        */

	       memmove (curloc+1,curloc,endloc-curloc+1);
	    /* ⨦  棜  妬 
	       婡    ⩞  室 
	       填 curloc ⤘ byte   驦
	       騦    carriage return                  */

		 *curloc=
		 key.ch[0]; /* RETURN in file */
		 curloc++;


		edit_clr_eol (scrnx,scrny);
		/* 坦     㟞
		     ENTER                                   */

		scrnx=0;
		scrny++;
		/*   scrnx , scrny 室  
		    棜                              */

		/* 磜  壜   ENTER
		        */

		if (scrny==MAX_LINES) {
		  scrny=MAX_LINES-1;
		   scrollup (0,0,LINE_LEN,scrny);
		}
		/*  棘     椞
		   磜      
		    				     */

		else scrolldn (scrnx,scrny);
		/*  磜  壜    ENTER
		                                       */

		gotoxy(scrnx,scrny);
		/* 夦    棜  
		    ENTER                                        */

		printline (curloc);
		/* 坦    椞 */

		endloc++;
		/*  填  室  ⢦  妬
		   嫘 ⤘ 㨘                  */

		break;

	  case '\b' : /* backspace */

	     if (curloc==buf) break ;
	     /*  棘    妬 
		磜  ᣜ     */

	     left ();
	     delete_char ();
	     /* 夦  ⩞   椞 
		᭦  㨘  婡  */

	     break;

	 case 9 : /* tab */
	    tab();
	 break;
	 case 11: /*control-K :   */
	     kill_line ();

	     break;
	 case 25    : /* control_y :   */

	     yank();

	     break;
	 default:

	 /* ⚮   buffer 夘 ᫦ */

	 if (endloc==buf+BUF_SIZE-2) break;
	 /*   buffer 夘 ᫦  磜 
	    ᚦ  㨘     */


	 if (scrnx==LINE_LEN )  break;
	 /*  棘  ⢦     磜
	     ᚦ  㨘                          */

	 memmove (curloc+1,curloc,endloc-curloc+1);
	 /* 磜  棜  buffer  ⤘ byte
	      ᤦ ⩞       㨘      */

	 *curloc=key.ch [0]; /*  㨘  㩘
				᚜  buffer            */

	 putch (*curloc);  /*  㨘 坜  椞 */

	 scrnx++; /* advance X */
	 gotoxy(scrnx,scrny);
	 printline (curloc+1); /* 坜    
				  㨘   ᚘ       */

	 curloc++;
	 endloc++;
	 /* O 填  室  ⢦  妬
	    嫘    ⤘ 㨘            */
	       }

	 gotoxy(scrnx,scrny);
	 /* O cursor 室  棜 㨘 
	       ᚘ 	     */

	  }
      } while ( key.ch[0]!=26 ) ;  /*   control-Z  夦
				        editor           */
}




/* 餦     室  填 p .  ਫ਼
   ᜠ 櫘 ᩦ  㨘 carriage return   ⢦
    妬                                                        */

void printline(register char *p)
{
register int i;

/* 靦   i  㢞   
   坦  ਫ਼                              */
i=scrnx;

/* 餦 ⮨  㩦  㨘 carriage
   return  ⮨  ᩦ  ⢦  妬  ⢦
    ⮦ 驜 80 㨜                         */
      while (*p!='\r' && *p && i<LINE_LEN ) {
	 putch (*p);
	 p++;
	 i++;
      }
}



/* ᚦ    ⮜    */

void yank (void)
{

char *p;

/* O 填 p 室    buffer  */
p=killbuf;

    /* ⨦     棜 
       buffer   buffer 餫  -
       棜  buffer  ⤘ 㨘 ៜ  */
    while (*p) {
      memmove (curloc+1,curloc,endloc-curloc+1);
       *curloc=*p;
       if (scrnx<LINE_LEN) {
	   putch (*curloc); /* 坜  㨘  椞 */
	   scrnx++;
       }
       curloc++;
       endloc++;
       p++;
    }

    /* 餜  梦    㨮   */
    printline (curloc);

}




/* ᭦       婡  cursor */

void kill_line (void)
{
   register int i;
   int k;
   char *p ,*killbufptr;

      /*  壘  carriage return  ᭦
	  ⭦  ᨫ edit	  */
       if (*curloc=='\r')  {
	  delete_char();
	  return;
       }




 /* 坦  椞 ⮨  棜 carriage return  */
 edit_clr_eol(scrnx,scrny);


/*婡 橦 㨜 夘    */


/*  填 p 室  㨘 ( buffer)
    o 婡 o cursor                   */
p=curloc;
i=0;

k=scrnx;
/* O 填 killbufptr 室  
     buffer                   */
killbufptr=killbuf;


/* 磜 ⤘ ⤘ 㨘  buffer  ⮨
    ᩦ  棜 carriage return   ⢦  妬  */

   while (*p!='\r' && p<endloc )  {
       gotoxy(k,scrny);
       printf(" ");
       k++;
       i++;
       *killbufptr=*p /*磜  㨘  buffer  */;
       p++;
	  if (killbufptr<killbuf+KILL_BUF_SIZE-2) killbufptr++;
   }


/* 磜  㨘    */
*killbufptr= '\0' ;


/* 磜     㣞 ( buffer) */
memmove (curloc,curloc+i ,endloc-curloc);


/* O 填 ⢦  妬 嫘 橦 㨜
    橦 夘  㡦  ᩞ  ᭞            */
endloc=endloc-i;
}

/*  稜  ᩫ   梦
     壜    棘      */

void replace(void)

{
register int len1;
char str1[80] ,str2[80];
char *p, *p2;

/* 坦     椞 
   ᚦ     ⢦ 
   㩦                                 */
clrline(MAX_LINES);
gotoxy(0,MAX_LINES);
printf ("enter string to replace: ") ;
edit_gets (str1);

/*   因 槦 ᚦ  
        㩦            */
clrline (MAX_LINES);
gotoxy(0,MAX_LINES);
printf("enter replacement : ");
edit_gets(str2);

/* 磜  填 p  矬  㨘
     棘    len1  -
        ⢦  -
   㩦                                               */
p=curloc;
len1=strlen(str1);



    while (* str1)  {

	/* ᮤ 㨘  㨘  buffer
	      ᤦ   
	   填 p  1 ⮨  ᩦ  ⢦
	    buffer   磜        */
	while  (*p && strncmp(str1,p,len1)) p++;


	if (!*p) break; /*   㡘  ⮦ ᩜ
			    ⢦  buffer         */


	/* 礦    */
	memmove (p,p+len1,endloc-p);

	/* o 填 ⢦  妬 餜  橦
	   㨜 ⮜    礜  */
	endloc=endloc-len1;


	/* ᚦ     */
	p2=str2;
	while (*p2) {
	    memmove (p+1,p,endloc-p+1);
	    *p=*p2;
	    p++;
	    endloc++;
	    p2++;
	}
    }
clrscr();


/* 婡  㨘 婡
        椞       */
p=curloc;
for (len1=scrny; len1>=0 && p>buf; ) {
    p--;
    if (*p=='\r') len1--;
}

/* 夦  髦 㨘  椞 */
if (*p=='\r') p++;

/*室  椞     ⚠
    ᩫ                             */
display_scrn (0,0,p);
help();
}


/*  㨘  */
void delete_char(void)
{

register int i;
char *p;

/* 夦  㨘  ⢦  ᯦ */
gotoxy(scrnx,scrny);

/*   㨘  ⢦  ᯦ 夘 
   carriage return 磜  椞  ' 
       磜 橦 㨜  -
   棜  磜 姢 '   穘
   . ⢦  穘  磜
    㨘 carriage return  坦  椞
       ⮦ 夜		       */

if  (*curloc=='\r') { /* RETURN */
if (scrnx<79){
    scrollup(0,scrny+1,LINE_LEN,MAX_LINES-1);
    memmove(curloc,curloc+1,endloc-curloc);
    p=curloc;
    endloc--;

    for (i=scrnx;i<79 && *p!='\r' && p<endloc;i++) p++;

    if (*p!='\r'&& p!=endloc){
	memmove(p+1,p,endloc-p+1);
       *p='\r';
    }

    display_scrn(scrnx,scrny,curloc);

    help();
   }

}

else {
/* ᭦  㨘  坦  
       ⮜ 夜                          */
    memmove(curloc,curloc+1,endloc-curloc);
    endloc--;
    printline(curloc);printf(" ");
    }
}



void tab(void)

{

char *pros;
int i,x,k;

pros=curloc;
x=scrnx;

while ( *pros!='\r' && x<LINE_LEN  && pros!=endloc)
{
  pros++;
  x++;
}

if ((*pros=='\r'  || pros==endloc)  && x<LINE_LEN)
{

k=LINE_LEN-x;
if (k<8) i=k;
else
i=8;
memmove(curloc+i,curloc,endloc-curloc+1);
endloc=endloc+i;
for (pros=curloc;pros<curloc+i;pros++)
    {
    *pros= ' ';
    }
    printline(curloc);
}

}



/* 室   㟜 */
void help(void)
{
   gotoxy(0,MAX_LINES);
   printf(helpline);
}



/* 夦 ⤘ 㨘  */
void left(void)
{

/*  壘    妬  磜  ᣜ  */
if (curloc==buf) return;

/*  O cursor 夜  ⩞  */
scrnx--;

/*    cursor 㫘  髦 㨘  ... */

     if (scrnx<0) {
	 scrnx=0;
	 upline(); /*  夦  磜  */

	 /* 婡  ⢦    磜 
	     cursor .夦  婫 㨘
	     buffer                                         */
	 while (*curloc!='\r') {
	     curloc++;
	     scrnx++;
	 }
     }
 /*    埜 姫ਫ਼ 夦  磜
      㨘  buffer                               */
     else curloc--;
}

/* 夦 ⤘ 㨘  */
void  right(void)
{
   /*  壘  ⢦  妬  磜  ᣜ  */
if (curloc+1>endloc) return;

/* ᤦ  填   1 */
scrnx++;

/*  壘  ⢦   夦  棜 */
if (scrnx>LINE_LEN || *curloc=='\r')  {
    scrnx=0;
    scrny++;

    if (scrny==MAX_LINES) { /*  壘  ⢦  椞 */
	 scrny=MAX_LINES-1;

	 /* 嫘  椞     
	    坜  稚           */
	 downline();


	 /* 夦    稚  */
	 curloc--;
	    while (*curloc!='\r') curloc--;
	 curloc++;
	 scrnx=0;
	}
    else curloc++;
   }
else curloc++;
}




void search(void)
{
char str[80];
register char *p;
int len , i ;

clrline(MAX_LINES); /* 坦    */
gotoxy(0,MAX_LINES) ;

/* 夦    ⢦  磜 */
printf (" search string: ");
edit_gets(str);

/*    夘  ⭦
    ᨫ  edit                         */
    if (!*str)
    {
    help();
    return;
    }

/*  填 p 室  穘 ⩞ ⩘  buffer
      len 眫  㡦  -
                                                 */
p=curloc;
len=strlen(str);


/* ᮤ    */
/* ᣜ 㨘 㨘 ⩘  
    夦   len   -
      坜   矬 p -
   x  ᩦ  ⢦ o buffer . ៜ
   ⨘ ᤦ    填 p  1 */

   while (*p && strncmp(str,p,len)) p++;

   /*   磜   ᣜ 
      ᨫ edit                               */
   if(!*p) {
     help();
     return; /* not found */
   }

/* ⭦      -
      */
i=0;
/*  填 p 餜  ៜ 稦 
   1 ⮨    室    磜
   carriage return .   
   i ᤜ  ៜ 稦  1        */

while (p>buf && *p!='\r') {
    p--;
    i++;
}
/*  填 p 室    
      i 室 橦 -
         婡 
     ᣜ                    */

if (scrny==0) ;
else {
  p++;
  i--;
     } ;
/* 磜  填  穘 嘪
   (curloc)  髦 㨘  -
    .夦    scrnx ,scrny 
     x ,y      㡘
     */
curloc=p+i;
scrnx=i;
scrny=0;

/* 坦  椞 .坦     㣘 
     ⟞   .餦   
   㟜 */
clrscr();
display_scrn(0,0,p);
help();

}



/* 夦       夘  
   因 㢞  棘 .                             */
void upline(void)

{
register int i; /*   㢞 */

char *p;   /* 㨘  buffer   棘 */


/*  棘    buffer  磜 
   ᣜ                                             */
if (curloc==buf) return;

/*   填 p 室  㨘  buffer
      棘                         */
p=curloc;

/*  棘  ⢦   ᣜ ⤘ 㨘  */
    if (*p=='\r') p--;

/* 夦    穘  */
for (; *p!='\r' && p>buf;p--);

/*  棘  髞   妬 
   磜   ᣜ                          */
if (*p!='\r' || p==buf) return ;

curloc=p;

/* 夦   㨘  磜  */
curloc--;

/* 靦    㢞  棘 */
i=scrnx;

/* 婡  ⢦   磜  */
while (*curloc!='\r' && curloc>=buf) curloc--;

/* 磜  cursor     */
scrny--;
scrnx=0;


/* 夦  髦 㨘   */
curloc++;

/*  壘    椞 嫘  椞
       餦      */
if (scrny<0) {
     scrolldn(0,0);
     scrny=0;
     gotoxy(0,0);
     printline(curloc);
}

/*  夘  磜  cursor  因
   㢞  㫘                                    */
while (i && *curloc!='\r') {
      curloc++;
      scrnx++;
      i--;
    }
}


/* 夦    ,  夘  
   因 㢞  棘 */
void downline(void)
{

register int i;  /*  㢞 */

char *p; /* 填  㨘  棘 */

/* 靦  i  㢞  棘 */
i=scrnx;

/*  磜  填 p   㨘  棘 */
p=curloc;

/* 夦    棜  (CR) */
    while (*p!='\r' && p<endloc) p++;

/*  壘     妬 
   磜  ᣜ                          */
if (p==endloc) return;

/* 夦  髦 㨘   CR */
p++;
curloc=p;

/*  cursor 嫘    棜  */
scrny++;
scrnx=0;

/*  㣘     椞  椞
   嫘     餜  
     */
if (scrny==MAX_LINES) {
    scrny=MAX_LINES-1;
    scrollup(0,0,LINE_LEN,MAX_LINES-1);
    gotoxy(scrnx,scrny);
    printline(curloc);
}

/* 磘  夘   婫 㨘
    棜  */
while (i && *curloc!='\r' && curloc<endloc) {
     curloc++;
     scrnx++;
     i--;
     }
}




/* 坜  椞 ⤦ (⮨ 24 )
    坜  ᧦ ⤦  
   椞                                             */
void display_scrn(int x, int y , char *p)
{
register int i;  /*  㢞 */

/* 夦  ⤦    椞 */
gotoxy(x,y);


i=x; /* 餜   㢞 棘 */


/* 餦  ⮨  婜  椞  ⮨
    驜                        */
while (y<MAX_LINES && *p)  {

    switch (*p) {
    /*   㨘 夘  carriage return ᝦ
       .O 填  ᤜ  1  填
        夜 0  夦   switch .       */
       case '\r': printf("\n");
		    y++;
		    i=0;
		    break;
    /*  ᨮ 櫜  80 㨜  
       餦  㨘 . 填   -
         1 .                                      */

	 default:   if (i<LINE_LEN) putch(*p);
		    i++;
		    }
   /*   填 p ᤜ  1 ⫩ 驫  磜 
       ᩦ  棜 㨘  buffer        */
		    p++;
		 }
    }





/* 室  囘 (24  ) */
void pagedown(void)
{
register int i;

/* 坦  椞 */
clrscr();

/*   ⩞  棘 ⩘  buffer
   夦 24    .  填
   curloc 室    24  -
       ⛜                       */
for (i=0;i<MAX_LINES && curloc<endloc; )  {
     if (*curloc=='\r') i++;
     curloc++;
     }


/* 餦   㟜  */
help();

/* 磜  cursor    椞 */
scrnx=0;
scrny=0;

/* 餦   24  */
display_scrn(0,0,curloc);
}



/* 夦  24  ⤦ */
void pageup(void)
{
register int i;

/* 坦  椞 */
clrscr();


/*   填 curloc 室  CR 夦
   ⤘ 㨘                         */
if (*curloc=='\r' && curloc>buf) curloc--;


/* 夦 24     buffer.
    ᩦ    buffer   ᣜ  */
for (i=0; i<MAX_LINES+1 && curloc>buf; ) {
      if (*curloc=='\r') i++;
      curloc--;
}


/*   ⮦ ᩜ    妬 ᤦ 
   填 curloc  2 驫  ᜠ  棜  */
if (i==MAX_LINES+1) curloc+=2;

/* 餦   㟜 */
help();

/* 夦     ठ  椞 */
scrnx=0;
scrny=0;

/* 坦    24  椞 */
display_scrn(0,0,curloc);
}




/*  夦     */
void home(void)
{

   /*  壘 㛞     ⭦
       ᨫ edit                               */
   if (scrnx==0) return;

   /*  棘  carriage return 夦 ⤘
      㨘                                     */
   if (*curloc=='\r') curloc-- ;

   /* 夦   磜 carriage return */
   while (*curloc!='\r') curloc--;

   /* 夦  髦 㨘   */
   curloc++;

   /* 磜  cursor     */
   scrnx=0;


}




/* 夦  ⢦   */
void gotoend(void)
{

    /*  棘 㛞  ⢦    ⭦
        ᨫ edit                                     */
    if ( *curloc=='\r' ||  curloc==endloc) return;


    /* ᣜ 㨘 㨘 ⮨  ᩦ   ⢦
        .磜  cursor  ⢦ 	 */
    while (*curloc!='\r' && curloc<endloc )
    {
       curloc++;
       scrnx++ ;
    }


}




/* 樫ࣘ 妬 */

load (char *fname)
{

FILE *fp;
char ch , *p;

/* 嚦      椦  ᚤਫ਼ */

/*     ᨮ  ᨫ ⭜
     ᨫ edit   0  坜 */
if ((fp=fopen(fname,"rb"))==NULL)
   return 0;


/*  填 p 室    buffer */
p=buf;


/* ᝦ 㨘  㨘     磜
   ៜ 㨘   ch .   㨘   -
     EOF 竜  㨘     㨘 -
   眫    室  填 p .槠  -
    p ᤜ  ⤘ .   填 p    ⛜
      buffer  㨜 禤  
   buffer                                                         */

 while (!feof(fp) && p!=buf+BUF_SIZE-2){
      ch=getc(fp);
      if(ch!='\n' && ch!=EOF) {
       *p=ch;
	   p++;
      }
}

/*    㨘 ਦ磜  buffer  EOF
    夦                                      */

*p= '\0';
fclose(fp);

/* 磜  填 curloc    buffer  
   填 endloc sto ⢦  buffer .  ᨫ load -
   ⭜  ᨫ edit   1  夜 櫠  -
    㨮  ᤦ                             */
curloc=buf;
endloc=p;
clrscr();
return 1;
}




/*  㡜 妬  */
save (char *fname)


{
FILE *fp;
char *p, name[80];

/*     妬 驘  椦   
   load  ᨮ 夦 ⤘ 稚 椦 
      靜   㛞 ⤦ 椦             */
if (!*fname) {
     printf("filename:  ");
     gets(name);
}
else strcpy(name,fname);


/*  嚦     ᩫ  
        ᨮ                 */

/*   ⩦  奦    ᨫ 坜
    ⭜   0  暨                       */
if ((fp=fopen(name,"wb"))==NULL)
     return 0;

/*  填 p 嫘     buffer */
p=buf;


/*   填 p  夘  ⢦  buffer ᝦ
    棜  buffer 㨘  㨘 .  
   㨘  ᝦ  夘  carriage return 
   靦    ⫦    -
   㨜 carriage return  line feed  ( 㨜 ⢦
    ) .ᤦ  填 p  ⤘ ⫩ 驫  -
   磜  ᩦ  棜 㨘  buffer.
   夦    餦  ᨫ edit 櫠
    ᩘ   .                                */
while (p!=endloc) {
      if (*p!='\r')
	 putc(*p,fp);
      else {
	   putc('\r',fp);
	   putc('\n',fp);
	   }
      p++;
}
fclose(fp);
return 1;
}



/*  ᝦ ⤘    暠 
     椞  ⨜   櫘 ᣜ  RETURN  */
void edit_gets(char *str)
{

char *p;

p=str;

/* ᚦ 㨜 ⮨  㩦  RETURN */
for (;;) {
    *str=getch();

    if (*str=='\r') {
       *str='\0'; /*   NULL 坜   */
       return;
     }

     if (*str=='b') {  /* backspace */
	  if (str>p) {
	  /* 夦  磜 㨘  */
	       str--;
	       putch('\b');
	       putch(' ');
	       putch ('\b');
	  }
     }
     else {
	 /* 坜  㨘  椞 */
	 putch(*str);
	 str++;
     }
  }
}




/* ᝜  靜  ⤜  cursor */
void cursor_pos(void)
{
  union REGS i ,o ;

  i.h.bh=0;
  i.h.ah=3;
  int86(16,&i,&o);

}



/*   cursor  ⤜ ⤜
   (0,0 夘    )  */
void gotoxy(int x,int y)
{
  union REGS i;

  i.h.dh=y;
  i.h.dl=x;
  i.h.ah=2;
  i.h.bh=0;
  int86(16, &i, &i);

}



 /* 坜  桢  櫘 夦 
       椞                    */
void clrline (int y)

{
   register int i;

   /* 夦         */
   gotoxy(0,y);

   /* ⮨  ⢦   坦  椞 */
   for (i=0; i<LINE_LEN;i++) putch (' ');
}




/* 坜  椞     棘 ⮨ 
   ⢦   .坜   ⮨    
   carriage return */
void edit_clr_eol ( int x, int y )
{
char *p;


/* 夜  填 p  矬  㨘  buffer
     棘   夜   㨘  
    椞
					  */
p=curloc;
gotoxy(x,y);

/*    夘 夘 櫜   ⚠ 㡦 
     填 p  室  ⢦   ᤦ
     p  ⤘ ⫩ 驫  ᩦ  棜 -
   㨘  坦  椞                              */
for (;x<LINE_LEN && *p!= '\r' && p<endloc; x++, p++ )  {
    printf (" ");
    }
}




/* 坜  椞 */
void clrscr(void)

{
   union REGS r ;

   r.h.ah=6;
   r.h.al=0;
   r.h.ch=0;
   r.h.cl=0;
   r.h.dh=MAX_LINES;
   r.h.dl=LINE_LEN;
   r.h.bh=7;
   int86(0x10,&r , &r);
}


/* ⨜     椞 */
void scrolldn (int x ,int y)
{
   union REGS r;
   r.h.ah=7;
   r.h.al=1;
   r.h.ch=y;
   r.h.cl=x;
   r.h.dh=MAX_LINES-1;
   r.h.dl=LINE_LEN;
   r.h.bh=7;
   int86(0x10, &r ,&r);
}



/*  ⨦    椞  ᩞ
     ⤜ ⤜          */
void scrollup (int topx, int topy ,int endx, int endy)
{
    union REGS r ;

    r.h.ah=6;
    r.h.al=1;
    r.h.ch=topy;
    r.h.cl=topx;
    r.h.dh=endy;
    r.h.dl=endx;
    r.h.bh=7;
    int86(0x10, &r ,&r);
}
